Index: trunk/IPs/systemC/processor/Morpheo/Common/include/Debug.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Common/include/Debug.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Common/include/Debug.h	(revision 138)
@@ -27,5 +27,4 @@
 #include "Common/include/Systemc.h"
 #include "Common/include/Message.h"
-#include "Common/include/FromString.h"
 #include "Common/include/ChangeCase.h"
 #include "Behavioural/include/Debug_component.h"
@@ -68,7 +67,7 @@
 #define debug_test_simulation_time                                      \
   (not debug_cycle_test or                                              \
-   ( (simulation_cycle() >= debug_cycle_start) and                    \
-    ((simulation_cycle() <= debug_cycle_stop) or                      \
-      (debug_cycle_stop == -1))))
+  ((simulation_cycle() >= debug_cycle_start) and                        \
+   ((simulation_cycle() <= debug_cycle_stop) or                         \
+    (debug_cycle_stop == -1))))
 #else
 #define debug_test_simulation_time true
@@ -82,7 +81,6 @@
                                                                         \
       if (debug_test_simulation_time and                                \
-          ((debug == DEBUG_ALL ) or					\
-           (( DEBUG_ ## level <= debug) and                             \
-            ( morpheo::behavioural::_model.get_debug(NAME_ ## component))))) \
+          (( DEBUG_ ## level <= debug) and                              \
+           ( morpheo::behavioural::_model.get_debug(NAME_ ## component)))) \
         {								\
           if (DEBUG_ ## level <= DEBUG_INFO)                            \
@@ -156,11 +154,11 @@
   do									\
     {									\
-      fprintf(stdout,_("%s "),MSG_BREAKPOINT);                                     \
-      fprintf(stdout,_("Breakpoint in file %s, line %d.\n"),__FILE__,__LINE__);    \
-      fprintf(stdout,_("%s "),MSG_NONE);                                           \
-      fprintf(stdout,str);								\
-      fprintf(stdout,_("\n"));                                                     \
-      fprintf(stdout,_("%s "),MSG_NONE);                                           \
-      fprintf(stdout,_("Enter any key to continue\n"));                            \
+      fmsg(_("%s "),MSG_BREAKPOINT);                                    \
+      fmsg(_("Breakpoint in file %s, line %d.\n"),__FILE__,__LINE__);   \
+      fmsg(_("%s "),MSG_NONE);                                          \
+      fmsg(str);							\
+      fmsg(_("\n"));                                                    \
+      fmsg(_("%s "),MSG_NONE);                                          \
+      fmsg(_("Enter any key to continue\n"));                           \
       getchar();							\
     } while(0)
@@ -182,33 +180,4 @@
 #endif
 
-
-  template<> inline debug_verbosity_t fromString<debug_verbosity_t> (const std::string& x)
-  {
-    std::string y=x;
-    LowerCase(y);
-
-    if ( (y.compare("0")     == 0) or
-         (y.compare("none")  == 0))
-      return DEBUG_NONE ;
-    if ( (y.compare("1")     == 0) or
-         (y.compare("info")  == 0))
-      return DEBUG_INFO ;
-    if ( (y.compare("2")     == 0) or
-         (y.compare("trace") == 0))
-      return DEBUG_TRACE;
-    if ( (y.compare("3")     == 0) or
-         (y.compare("func")  == 0))
-      return DEBUG_FUNC ;
-    if ( (y.compare("4")     == 0) or
-         (y.compare("all")   == 0))
-      return DEBUG_ALL  ;
-
-#ifdef DEBUG
-    return DEBUG;
-#else
-    return DEBUG_NONE ;
-#endif
-  }
-
 }; // end namespace morpheo
 #endif // !DEBUG_H
Index: trunk/IPs/systemC/processor/Morpheo/Common/include/Debug_type.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Common/include/Debug_type.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Common/include/Debug_type.h	(revision 138)
@@ -15,4 +15,7 @@
  */
 
+#include "Common/include/ToString.h"
+#include "Common/include/FromString.h"
+
 
 namespace morpheo {
@@ -27,4 +30,46 @@
   } debug_verbosity_t;
 
+  template<> inline std::string toString<debug_verbosity_t>(const debug_verbosity_t& x)
+  {
+    switch (x)
+      {
+      case DEBUG_NONE  : return "debug_none" ; break;
+      case DEBUG_INFO  : return "debug_info" ; break;
+      case DEBUG_TRACE : return "debug_trace"; break;
+      case DEBUG_FUNC  : return "debug_func" ; break;
+      case DEBUG_ALL   : return "debug_all"  ; break;
+      default    : return ""      ; break;
+      }
+  };
+
+  template<> inline debug_verbosity_t fromString<debug_verbosity_t>(const std::string& x)
+  {
+    if ((x.compare(toString(static_cast<uint32_t>(DEBUG_NONE ))) == 0) or
+        (x.compare(toString(                      DEBUG_NONE  )) == 0))
+      return DEBUG_NONE;
+
+    if ((x.compare(toString(static_cast<uint32_t>(DEBUG_INFO ))) == 0) or
+        (x.compare(toString(                      DEBUG_INFO  )) == 0))
+      return DEBUG_INFO;
+
+    if ((x.compare(toString(static_cast<uint32_t>(DEBUG_TRACE))) == 0) or
+        (x.compare(toString(                      DEBUG_TRACE )) == 0))
+      return DEBUG_TRACE;
+
+    if ((x.compare(toString(static_cast<uint32_t>(DEBUG_FUNC ))) == 0) or
+        (x.compare(toString(                      DEBUG_FUNC  )) == 0))
+      return DEBUG_FUNC;
+
+    if ((x.compare(toString(static_cast<uint32_t>(DEBUG_ALL  ))) == 0) or
+        (x.compare(toString(                      DEBUG_ALL   )) == 0))
+      return DEBUG_ALL;
+
+#ifdef DEBUG
+    return DEBUG;
+#else
+    return DEBUG_NONE ;
+#endif
+  };
+
 }; // end namespace morpheo
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Common/include/ErrorMorpheo.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Common/include/ErrorMorpheo.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Common/include/ErrorMorpheo.h	(revision 138)
@@ -39,5 +39,5 @@
       _msg = toString(_("%s %s"),MSG_ERROR,msg.c_str());
 #endif
-      msg("%s",_msg.c_str());
+//     msg("%s",_msg.c_str());
     }
   public  :             ~ErrorMorpheo (void)       throw() {}
Index: trunk/IPs/systemC/processor/Morpheo/Common/include/Time.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Common/include/Time.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Common/include/Time.h	(revision 138)
@@ -10,4 +10,5 @@
 #include <sys/time.h>
 #include "Common/include/Systemc.h"
+#include "Common/include/Message.h"
 
 namespace morpheo {
